#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_LUID_SIZE_KHR")]
pub const LUID_SIZE_KHR: u32 = 8;
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_EXTERNAL_MEMORY_CAPABILITIES_SPEC_VERSION")]
pub const KHR_EXTERNAL_MEMORY_CAPABILITIES_SPEC_VERSION: u32 = 1;
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_EXTERNAL_MEMORY_CAPABILITIES_EXTENSION_NAME")]
pub const KHR_EXTERNAL_MEMORY_CAPABILITIES_EXTENSION_NAME: *const std::os::raw::c_char = crate::cstr!("VK_KHR_external_memory_capabilities");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_GET_PHYSICAL_DEVICE_EXTERNAL_BUFFER_PROPERTIES_KHR: *const std::os::raw::c_char = crate::cstr!("vkGetPhysicalDeviceExternalBufferPropertiesKHR");
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryHandleTypeFlagsKHR.html)) · Alias <br/> VkExternalMemoryHandleTypeFlags - Bitmask of VkExternalMemoryHandleTypeFlagBits\n[](#_c_specification)C Specification\n----------\n\n```\n// Provided by VK_VERSION_1_1\ntypedef VkFlags VkExternalMemoryHandleTypeFlags;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_memory_capabilities\ntypedef VkExternalMemoryHandleTypeFlags VkExternalMemoryHandleTypeFlagsKHR;\n```\n[](#_description)Description\n----------\n\n[`crate::vk::ExternalMemoryHandleTypeFlagBits`] is a bitmask type for setting a mask\nof zero or more [VkExternalMemoryHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryHandleTypeFlagBits.html).\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExportMemoryAllocateInfo`], [`crate::vk::ExternalMemoryBufferCreateInfo`], [VkExternalMemoryHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryHandleTypeFlagBits.html), [`crate::vk::ExternalMemoryImageCreateInfo`], [`crate::vk::ExternalMemoryProperties`]\n"]
#[doc(alias = "VkExternalMemoryHandleTypeFlagsKHR")]
#[allow(non_camel_case_types)]
pub type ExternalMemoryHandleTypeFlagsKHR = crate::vk1_1::ExternalMemoryHandleTypeFlags;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryFeatureFlagsKHR.html)) · Alias <br/> VkExternalMemoryFeatureFlags - Bitmask of VkExternalMemoryFeatureFlagBits\n[](#_c_specification)C Specification\n----------\n\n```\n// Provided by VK_VERSION_1_1\ntypedef VkFlags VkExternalMemoryFeatureFlags;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_memory_capabilities\ntypedef VkExternalMemoryFeatureFlags VkExternalMemoryFeatureFlagsKHR;\n```\n[](#_description)Description\n----------\n\n[`crate::vk::ExternalMemoryFeatureFlagBits`] is a bitmask type for setting a mask of\nzero or more [VkExternalMemoryFeatureFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryFeatureFlagBits.html).\n[](#_see_also)See Also\n----------\n\n[VkExternalMemoryFeatureFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryFeatureFlagBits.html), [`crate::vk::ExternalMemoryProperties`]\n"]
#[doc(alias = "VkExternalMemoryFeatureFlagsKHR")]
#[allow(non_camel_case_types)]
pub type ExternalMemoryFeatureFlagsKHR = crate::vk1_1::ExternalMemoryFeatureFlags;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryHandleTypeFlagBitsKHR.html)) · Alias <br/> VkExternalMemoryHandleTypeFlagBits - Bit specifying external memory handle types\n[](#_c_specification)C Specification\n----------\n\nPossible values of[`crate::vk::PhysicalDeviceExternalImageFormatInfo::handle_type`], specifying\nan external memory handle type, are:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef enum VkExternalMemoryHandleTypeFlagBits {\n    VK_EXTERNAL_MEMORY_HANDLE_TYPE_OPAQUE_FD_BIT = 0x00000001,\n    VK_EXTERNAL_MEMORY_HANDLE_TYPE_OPAQUE_WIN32_BIT = 0x00000002,\n    VK_EXTERNAL_MEMORY_HANDLE_TYPE_OPAQUE_WIN32_KMT_BIT = 0x00000004,\n    VK_EXTERNAL_MEMORY_HANDLE_TYPE_D3D11_TEXTURE_BIT = 0x00000008,\n    VK_EXTERNAL_MEMORY_HANDLE_TYPE_D3D11_TEXTURE_KMT_BIT = 0x00000010,\n    VK_EXTERNAL_MEMORY_HANDLE_TYPE_D3D12_HEAP_BIT = 0x00000020,\n    VK_EXTERNAL_MEMORY_HANDLE_TYPE_D3D12_RESOURCE_BIT = 0x00000040,\n  // Provided by VK_EXT_external_memory_dma_buf\n    VK_EXTERNAL_MEMORY_HANDLE_TYPE_DMA_BUF_BIT_EXT = 0x00000200,\n  // Provided by VK_ANDROID_external_memory_android_hardware_buffer\n    VK_EXTERNAL_MEMORY_HANDLE_TYPE_ANDROID_HARDWARE_BUFFER_BIT_ANDROID = 0x00000400,\n  // Provided by VK_EXT_external_memory_host\n    VK_EXTERNAL_MEMORY_HANDLE_TYPE_HOST_ALLOCATION_BIT_EXT = 0x00000080,\n  // Provided by VK_EXT_external_memory_host\n    VK_EXTERNAL_MEMORY_HANDLE_TYPE_HOST_MAPPED_FOREIGN_MEMORY_BIT_EXT = 0x00000100,\n  // Provided by VK_FUCHSIA_external_memory\n    VK_EXTERNAL_MEMORY_HANDLE_TYPE_ZIRCON_VMO_BIT_FUCHSIA = 0x00000800,\n  // Provided by VK_NV_external_memory_rdma\n    VK_EXTERNAL_MEMORY_HANDLE_TYPE_RDMA_ADDRESS_BIT_NV = 0x00001000,\n  // Provided by VK_KHR_external_memory_capabilities\n    VK_EXTERNAL_MEMORY_HANDLE_TYPE_OPAQUE_FD_BIT_KHR = VK_EXTERNAL_MEMORY_HANDLE_TYPE_OPAQUE_FD_BIT,\n  // Provided by VK_KHR_external_memory_capabilities\n    VK_EXTERNAL_MEMORY_HANDLE_TYPE_OPAQUE_WIN32_BIT_KHR = VK_EXTERNAL_MEMORY_HANDLE_TYPE_OPAQUE_WIN32_BIT,\n  // Provided by VK_KHR_external_memory_capabilities\n    VK_EXTERNAL_MEMORY_HANDLE_TYPE_OPAQUE_WIN32_KMT_BIT_KHR = VK_EXTERNAL_MEMORY_HANDLE_TYPE_OPAQUE_WIN32_KMT_BIT,\n  // Provided by VK_KHR_external_memory_capabilities\n    VK_EXTERNAL_MEMORY_HANDLE_TYPE_D3D11_TEXTURE_BIT_KHR = VK_EXTERNAL_MEMORY_HANDLE_TYPE_D3D11_TEXTURE_BIT,\n  // Provided by VK_KHR_external_memory_capabilities\n    VK_EXTERNAL_MEMORY_HANDLE_TYPE_D3D11_TEXTURE_KMT_BIT_KHR = VK_EXTERNAL_MEMORY_HANDLE_TYPE_D3D11_TEXTURE_KMT_BIT,\n  // Provided by VK_KHR_external_memory_capabilities\n    VK_EXTERNAL_MEMORY_HANDLE_TYPE_D3D12_HEAP_BIT_KHR = VK_EXTERNAL_MEMORY_HANDLE_TYPE_D3D12_HEAP_BIT,\n  // Provided by VK_KHR_external_memory_capabilities\n    VK_EXTERNAL_MEMORY_HANDLE_TYPE_D3D12_RESOURCE_BIT_KHR = VK_EXTERNAL_MEMORY_HANDLE_TYPE_D3D12_RESOURCE_BIT,\n} VkExternalMemoryHandleTypeFlagBits;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_memory_capabilities\ntypedef VkExternalMemoryHandleTypeFlagBits VkExternalMemoryHandleTypeFlagBitsKHR;\n```\n[](#_description)Description\n----------\n\n* [`crate::vk::ExternalMemoryHandleTypeFlagBits::OPAQUE_FD`] specifies a POSIX\n  file descriptor handle that has only limited valid usage outside of\n  Vulkan and other compatible APIs.\n  It **must** be compatible with the POSIX system calls `dup`, `dup2`,`close`, and the non-standard system call `dup3`.\n  Additionally, it **must** be transportable over a socket using an`SCM_RIGHTS` control message.\n  It owns a reference to the underlying memory resource represented by its\n  Vulkan memory object.\n\n* [`crate::vk::ExternalMemoryHandleTypeFlagBits::OPAQUE_WIN32`] specifies an NT\n  handle that has only limited valid usage outside of Vulkan and other\n  compatible APIs.\n  It **must** be compatible with the functions `DuplicateHandle`,`CloseHandle`, `CompareObjectHandles`, `GetHandleInformation`,\n  and `SetHandleInformation`.\n  It owns a reference to the underlying memory resource represented by its\n  Vulkan memory object.\n\n* [`crate::vk::ExternalMemoryHandleTypeFlagBits::OPAQUE_WIN32_KMT`] specifies a\n  global share handle that has only limited valid usage outside of Vulkan\n  and other compatible APIs.\n  It is not compatible with any native APIs.\n  It does not own a reference to the underlying memory resource\n  represented by its Vulkan memory object, and will therefore become\n  invalid when all Vulkan memory objects associated with it are destroyed.\n\n* [`crate::vk::ExternalMemoryHandleTypeFlagBits::D3D11_TEXTURE`] specifies an NT\n  handle returned by `IDXGIResource1`::`CreateSharedHandle`referring to a Direct3D 10 or 11 texture resource.\n  It owns a reference to the memory used by the Direct3D resource.\n\n* [`crate::vk::ExternalMemoryHandleTypeFlagBits::D3D11_TEXTURE_KMT`] specifies a\n  global share handle returned by `IDXGIResource`::`GetSharedHandle`referring to a Direct3D 10 or 11 texture resource.\n  It does not own a reference to the underlying Direct3D resource, and\n  will therefore become invalid when all Vulkan memory objects and\n  Direct3D resources associated with it are destroyed.\n\n* [`crate::vk::ExternalMemoryHandleTypeFlagBits::D3D12_HEAP`] specifies an NT\n  handle returned by `ID3D12Device`::`CreateSharedHandle` referring\n  to a Direct3D 12 heap resource.\n  It owns a reference to the resources used by the Direct3D heap.\n\n* [`crate::vk::ExternalMemoryHandleTypeFlagBits::D3D12_RESOURCE`] specifies an NT\n  handle returned by `ID3D12Device`::`CreateSharedHandle` referring\n  to a Direct3D 12 committed resource.\n  It owns a reference to the memory used by the Direct3D resource.\n\n* [`crate::vk::ExternalMemoryHandleTypeFlagBits::HOST_ALLOCATION_EXT`] specifies a\n  host pointer returned by a host memory allocation command.\n  It does not own a reference to the underlying memory resource, and will\n  therefore become invalid if the host memory is freed.\n\n* [`crate::vk::ExternalMemoryHandleTypeFlagBits::HOST_MAPPED_FOREIGN_MEMORY_EXT`]specifies a host pointer to *host mapped foreign memory*.\n  It does not own a reference to the underlying memory resource, and will\n  therefore become invalid if the foreign memory is unmapped or otherwise\n  becomes no longer available.\n\n* [`crate::vk::ExternalMemoryHandleTypeFlagBits::DMA_BUF_EXT`] is a file\n  descriptor for a Linux dma\\_buf.\n  It owns a reference to the underlying memory resource represented by its\n  Vulkan memory object.\n\n* [`crate::vk::ExternalMemoryHandleTypeFlagBits::ANDROID_HARDWARE_BUFFER_ANDROID`]specifies an [`crate::vk::AHardwareBuffer`] object defined by the Android NDK.\n  See [Android Hardware Buffers](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#memory-external-android-hardware-buffer)for more details of this handle type.\n\n* [`crate::vk::ExternalMemoryHandleTypeFlagBits::ZIRCON_VMO_FUCHSIA`] is a Zircon\n  handle to a virtual memory object.\n\n* [`crate::vk::ExternalMemoryHandleTypeFlagBits::RDMA_ADDRESS_NV`] is a handle to\n  an allocation accessible by remote devices.\n  It owns a reference to the underlying memory resource represented by its\n  Vulkan memory object.\n\nSome external memory handle types can only be shared within the same\nunderlying physical device and/or the same driver version, as defined in the\nfollowing table:\n\n|                            Handle type                             |[`crate::vk::PhysicalDeviceIDProperties`]::`driverUUID`|[`crate::vk::PhysicalDeviceIDProperties`]::`deviceUUID`|\n|--------------------------------------------------------------------|--------------------------------------------|--------------------------------------------|\n|           [`crate::vk::ExternalMemoryHandleTypeFlagBits::OPAQUE_FD`]           |                 Must match                 |                 Must match                 |\n|         [`crate::vk::ExternalMemoryHandleTypeFlagBits::OPAQUE_WIN32`]          |                 Must match                 |                 Must match                 |\n|       [`crate::vk::ExternalMemoryHandleTypeFlagBits::OPAQUE_WIN32_KMT`]        |                 Must match                 |                 Must match                 |\n|         [`crate::vk::ExternalMemoryHandleTypeFlagBits::D3D11_TEXTURE`]         |                 Must match                 |                 Must match                 |\n|       [`crate::vk::ExternalMemoryHandleTypeFlagBits::D3D11_TEXTURE_KMT`]       |                 Must match                 |                 Must match                 |\n|          [`crate::vk::ExternalMemoryHandleTypeFlagBits::D3D12_HEAP`]           |                 Must match                 |                 Must match                 |\n|        [`crate::vk::ExternalMemoryHandleTypeFlagBits::D3D12_RESOURCE`]         |                 Must match                 |                 Must match                 |\n|      [`crate::vk::ExternalMemoryHandleTypeFlagBits::HOST_ALLOCATION_EXT`]      |               No restriction               |               No restriction               |\n|[`crate::vk::ExternalMemoryHandleTypeFlagBits::HOST_MAPPED_FOREIGN_MEMORY_EXT`] |               No restriction               |               No restriction               |\n|          [`crate::vk::ExternalMemoryHandleTypeFlagBits::DMA_BUF_EXT`]          |               No restriction               |               No restriction               |\n|[`crate::vk::ExternalMemoryHandleTypeFlagBits::ANDROID_HARDWARE_BUFFER_ANDROID`]|               No restriction               |               No restriction               |\n|      [`crate::vk::ExternalMemoryHandleTypeFlagBits::ZIRCON_VMO_FUCHSIA`]       |               No restriction               |               No restriction               |\n|        [`crate::vk::ExternalMemoryHandleTypeFlagBits::RDMA_ADDRESS_NV`]        |               No restriction               |               No restriction               |\n\n|   |Note<br/><br/>The above table does not restrict the drivers and devices with which[`crate::vk::ExternalMemoryHandleTypeFlagBits::HOST_ALLOCATION_EXT`] and[`crate::vk::ExternalMemoryHandleTypeFlagBits::HOST_MAPPED_FOREIGN_MEMORY_EXT`] **may**be shared, as these handle types inherently mean memory that does not come<br/>from the same device, as they import memory from the host or a foreign<br/>device, respectively.|\n|---|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\n|   |Note<br/><br/>Even though the above table does not restrict the drivers and devices with<br/>which [`crate::vk::ExternalMemoryHandleTypeFlagBits::DMA_BUF_EXT`] **may** be shared,<br/>query mechanisms exist in the Vulkan API that prevent the import of<br/>incompatible dma-bufs (such as [`crate::vk::DeviceLoader::get_memory_fd_properties_khr`]) and that<br/>prevent incompatible usage of dma-bufs (such as[`crate::vk::PhysicalDeviceExternalBufferInfo`] and[`crate::vk::PhysicalDeviceExternalImageFormatInfo`]).|\n|---|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExternalMemoryHandleTypeFlagBits`], [`crate::vk::ImportMemoryFdInfoKHR`], [`crate::vk::ImportMemoryHostPointerInfoEXT`], [`crate::vk::ImportMemoryWin32HandleInfoKHR`], [`crate::vk::ImportMemoryZirconHandleInfoFUCHSIA`], [`crate::vk::MemoryGetFdInfoKHR`], [`crate::vk::MemoryGetRemoteAddressInfoNV`], [`crate::vk::MemoryGetWin32HandleInfoKHR`], [`crate::vk::MemoryGetZirconHandleInfoFUCHSIA`], [`crate::vk::PhysicalDeviceExternalBufferInfo`], [`crate::vk::PhysicalDeviceExternalImageFormatInfo`], [`crate::vk::DeviceLoader::get_memory_fd_properties_khr`], [`crate::vk::DeviceLoader::get_memory_host_pointer_properties_ext`], [`crate::vk::DeviceLoader::get_memory_win32_handle_properties_khr`], [`crate::vk::DeviceLoader::get_memory_zircon_handle_properties_fuchsia`]\n"]
#[doc(alias = "VkExternalMemoryHandleTypeFlagBitsKHR")]
#[allow(non_camel_case_types)]
pub type ExternalMemoryHandleTypeFlagBitsKHR = crate::vk1_1::ExternalMemoryHandleTypeFlagBits;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryFeatureFlagBitsKHR.html)) · Alias <br/> VkExternalMemoryFeatureFlagBits - Bitmask specifying features of an external memory handle type\n[](#_c_specification)C Specification\n----------\n\nBits which **may** be set in[`crate::vk::ExternalMemoryProperties::external_memory_features`], specifying\nfeatures of an external memory handle type, are:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef enum VkExternalMemoryFeatureFlagBits {\n    VK_EXTERNAL_MEMORY_FEATURE_DEDICATED_ONLY_BIT = 0x00000001,\n    VK_EXTERNAL_MEMORY_FEATURE_EXPORTABLE_BIT = 0x00000002,\n    VK_EXTERNAL_MEMORY_FEATURE_IMPORTABLE_BIT = 0x00000004,\n  // Provided by VK_KHR_external_memory_capabilities\n    VK_EXTERNAL_MEMORY_FEATURE_DEDICATED_ONLY_BIT_KHR = VK_EXTERNAL_MEMORY_FEATURE_DEDICATED_ONLY_BIT,\n  // Provided by VK_KHR_external_memory_capabilities\n    VK_EXTERNAL_MEMORY_FEATURE_EXPORTABLE_BIT_KHR = VK_EXTERNAL_MEMORY_FEATURE_EXPORTABLE_BIT,\n  // Provided by VK_KHR_external_memory_capabilities\n    VK_EXTERNAL_MEMORY_FEATURE_IMPORTABLE_BIT_KHR = VK_EXTERNAL_MEMORY_FEATURE_IMPORTABLE_BIT,\n} VkExternalMemoryFeatureFlagBits;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_memory_capabilities\ntypedef VkExternalMemoryFeatureFlagBits VkExternalMemoryFeatureFlagBitsKHR;\n```\n[](#_description)Description\n----------\n\n* [`crate::vk::ExternalMemoryFeatureFlagBits::DEDICATED_ONLY`] specifies that\n  images or buffers created with the specified parameters and handle type**must** use the mechanisms defined by [`crate::vk::MemoryDedicatedRequirements`]and [`crate::vk::MemoryDedicatedAllocateInfo`] to create (or import) a\n  dedicated allocation for the image or buffer.\n\n* [`crate::vk::ExternalMemoryFeatureFlagBits::EXPORTABLE`] specifies that handles\n  of this type **can** be exported from Vulkan memory objects.\n\n* [`crate::vk::ExternalMemoryFeatureFlagBits::IMPORTABLE`] specifies that handles\n  of this type **can** be imported as Vulkan memory objects.\n\nBecause their semantics in external APIs roughly align with that of an image\nor buffer with a dedicated allocation in Vulkan, implementations are**required** to report [`crate::vk::ExternalMemoryFeatureFlagBits::DEDICATED_ONLY`] for\nthe following external handle types:\n\n* [`crate::vk::ExternalMemoryHandleTypeFlagBits::D3D11_TEXTURE`]\n\n* [`crate::vk::ExternalMemoryHandleTypeFlagBits::D3D11_TEXTURE_KMT`]\n\n* [`crate::vk::ExternalMemoryHandleTypeFlagBits::D3D12_RESOURCE`]\n\n* [`crate::vk::ExternalMemoryHandleTypeFlagBits::ANDROID_HARDWARE_BUFFER_ANDROID`]for images only\n\nImplementations **must** not report[`crate::vk::ExternalMemoryFeatureFlagBits::DEDICATED_ONLY`] for buffers with\nexternal handle type[`crate::vk::ExternalMemoryHandleTypeFlagBits::ANDROID_HARDWARE_BUFFER_ANDROID`].\nImplementations **must** not report[`crate::vk::ExternalMemoryFeatureFlagBits::DEDICATED_ONLY`] for images or buffers\nwith external handle type[`crate::vk::ExternalMemoryHandleTypeFlagBits::HOST_ALLOCATION_EXT`], or[`crate::vk::ExternalMemoryHandleTypeFlagBits::HOST_MAPPED_FOREIGN_MEMORY_EXT`].\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExternalMemoryFeatureFlagBits`]\n"]
#[doc(alias = "VkExternalMemoryFeatureFlagBitsKHR")]
#[allow(non_camel_case_types)]
pub type ExternalMemoryFeatureFlagBitsKHR = crate::vk1_1::ExternalMemoryFeatureFlagBits;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryPropertiesKHR.html)) · Alias <br/> VkExternalMemoryProperties - Structure specifying external memory handle type capabilities\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::ExternalMemoryProperties`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkExternalMemoryProperties {\n    VkExternalMemoryFeatureFlags       externalMemoryFeatures;\n    VkExternalMemoryHandleTypeFlags    exportFromImportedHandleTypes;\n    VkExternalMemoryHandleTypeFlags    compatibleHandleTypes;\n} VkExternalMemoryProperties;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_memory_capabilities\ntypedef VkExternalMemoryProperties VkExternalMemoryPropertiesKHR;\n```\n[](#_members)Members\n----------\n\n* `externalMemoryFeatures` is a bitmask of[VkExternalMemoryFeatureFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryFeatureFlagBits.html) specifying the features of`handleType`.\n\n* `exportFromImportedHandleTypes` is a bitmask of[VkExternalMemoryHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryHandleTypeFlagBits.html) specifying which types of\n  imported handle `handleType` **can** be exported from.\n\n* `compatibleHandleTypes` is a bitmask of[VkExternalMemoryHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryHandleTypeFlagBits.html) specifying handle types which**can** be specified at the same time as `handleType` when creating an\n  image compatible with external memory.\n[](#_description)Description\n----------\n\n`compatibleHandleTypes` **must** include at least `handleType`.\nInclusion of a handle type in `compatibleHandleTypes` does not imply the\nvalues returned in [`crate::vk::ImageFormatProperties2`] will be the same when[`crate::vk::PhysicalDeviceExternalImageFormatInfo::handle_type`] is set to\nthat type.\nThe application is responsible for querying the capabilities of all handle\ntypes intended for concurrent use in a single image and intersecting them to\nobtain the compatible set of capabilities.\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExternalBufferProperties`], [`crate::vk::ExternalImageFormatProperties`], [`crate::vk::ExternalMemoryFeatureFlagBits`], [`crate::vk::ExternalMemoryHandleTypeFlagBits`]\n"]
#[doc(alias = "VkExternalMemoryPropertiesKHR")]
#[allow(non_camel_case_types)]
pub type ExternalMemoryPropertiesKHR = crate::vk1_1::ExternalMemoryProperties;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryPropertiesKHR.html)) · Alias <br/> VkExternalMemoryProperties - Structure specifying external memory handle type capabilities\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::ExternalMemoryProperties`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkExternalMemoryProperties {\n    VkExternalMemoryFeatureFlags       externalMemoryFeatures;\n    VkExternalMemoryHandleTypeFlags    exportFromImportedHandleTypes;\n    VkExternalMemoryHandleTypeFlags    compatibleHandleTypes;\n} VkExternalMemoryProperties;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_memory_capabilities\ntypedef VkExternalMemoryProperties VkExternalMemoryPropertiesKHR;\n```\n[](#_members)Members\n----------\n\n* `externalMemoryFeatures` is a bitmask of[VkExternalMemoryFeatureFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryFeatureFlagBits.html) specifying the features of`handleType`.\n\n* `exportFromImportedHandleTypes` is a bitmask of[VkExternalMemoryHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryHandleTypeFlagBits.html) specifying which types of\n  imported handle `handleType` **can** be exported from.\n\n* `compatibleHandleTypes` is a bitmask of[VkExternalMemoryHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryHandleTypeFlagBits.html) specifying handle types which**can** be specified at the same time as `handleType` when creating an\n  image compatible with external memory.\n[](#_description)Description\n----------\n\n`compatibleHandleTypes` **must** include at least `handleType`.\nInclusion of a handle type in `compatibleHandleTypes` does not imply the\nvalues returned in [`crate::vk::ImageFormatProperties2`] will be the same when[`crate::vk::PhysicalDeviceExternalImageFormatInfo::handle_type`] is set to\nthat type.\nThe application is responsible for querying the capabilities of all handle\ntypes intended for concurrent use in a single image and intersecting them to\nobtain the compatible set of capabilities.\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExternalBufferProperties`], [`crate::vk::ExternalImageFormatProperties`], [`crate::vk::ExternalMemoryFeatureFlagBits`], [`crate::vk::ExternalMemoryHandleTypeFlagBits`]\n"]
#[doc(alias = "VkExternalMemoryPropertiesKHR")]
#[allow(non_camel_case_types)]
pub type ExternalMemoryPropertiesKHRBuilder<'a> = crate::vk1_1::ExternalMemoryPropertiesBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceExternalImageFormatInfoKHR.html)) · Alias <br/> VkPhysicalDeviceExternalImageFormatInfo - Structure specifying external image creation parameters\n[](#_c_specification)C Specification\n----------\n\nTo determine the image capabilities compatible with an external memory\nhandle type, add a [`crate::vk::PhysicalDeviceExternalImageFormatInfo`] structure\nto the `pNext` chain of the [`crate::vk::PhysicalDeviceImageFormatInfo2`]structure and a [`crate::vk::ExternalImageFormatProperties`] structure to the`pNext` chain of the [`crate::vk::ImageFormatProperties2`] structure.\n\nThe [`crate::vk::PhysicalDeviceExternalImageFormatInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkPhysicalDeviceExternalImageFormatInfo {\n    VkStructureType                       sType;\n    const void*                           pNext;\n    VkExternalMemoryHandleTypeFlagBits    handleType;\n} VkPhysicalDeviceExternalImageFormatInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_memory_capabilities\ntypedef VkPhysicalDeviceExternalImageFormatInfo VkPhysicalDeviceExternalImageFormatInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `handleType` is a [VkExternalMemoryHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryHandleTypeFlagBits.html) value\n  specifying the memory handle type that will be used with the memory\n  associated with the image.\n[](#_description)Description\n----------\n\nIf `handleType` is 0, [`crate::vk::PFN_vkGetPhysicalDeviceImageFormatProperties2`]will behave as if [`crate::vk::PhysicalDeviceExternalImageFormatInfo`] was not\npresent, and [`crate::vk::ExternalImageFormatProperties`] will be ignored.\n\nIf `handleType` is not compatible with the `format`, `type`,`tiling`, `usage`, and `flags` specified in[`crate::vk::PhysicalDeviceImageFormatInfo2`], then[`crate::vk::PFN_vkGetPhysicalDeviceImageFormatProperties2`] returns[`crate::vk::Result::ERROR_FORMAT_NOT_SUPPORTED`].\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceExternalImageFormatInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_EXTERNAL_IMAGE_FORMAT_INFO`]\n\n* []() VUID-VkPhysicalDeviceExternalImageFormatInfo-handleType-parameter  \n   If `handleType` is not `0`, `handleType` **must** be a valid [VkExternalMemoryHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryHandleTypeFlagBits.html) value\n[](#_see_also)See Also\n----------\n\n[VkExternalMemoryHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryHandleTypeFlagBits.html), [`crate::vk::StructureType`]\n"]
#[doc(alias = "VkPhysicalDeviceExternalImageFormatInfoKHR")]
#[allow(non_camel_case_types)]
pub type PhysicalDeviceExternalImageFormatInfoKHR = crate::vk1_1::PhysicalDeviceExternalImageFormatInfo;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceExternalImageFormatInfoKHR.html)) · Alias <br/> VkPhysicalDeviceExternalImageFormatInfo - Structure specifying external image creation parameters\n[](#_c_specification)C Specification\n----------\n\nTo determine the image capabilities compatible with an external memory\nhandle type, add a [`crate::vk::PhysicalDeviceExternalImageFormatInfo`] structure\nto the `pNext` chain of the [`crate::vk::PhysicalDeviceImageFormatInfo2`]structure and a [`crate::vk::ExternalImageFormatProperties`] structure to the`pNext` chain of the [`crate::vk::ImageFormatProperties2`] structure.\n\nThe [`crate::vk::PhysicalDeviceExternalImageFormatInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkPhysicalDeviceExternalImageFormatInfo {\n    VkStructureType                       sType;\n    const void*                           pNext;\n    VkExternalMemoryHandleTypeFlagBits    handleType;\n} VkPhysicalDeviceExternalImageFormatInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_memory_capabilities\ntypedef VkPhysicalDeviceExternalImageFormatInfo VkPhysicalDeviceExternalImageFormatInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `handleType` is a [VkExternalMemoryHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryHandleTypeFlagBits.html) value\n  specifying the memory handle type that will be used with the memory\n  associated with the image.\n[](#_description)Description\n----------\n\nIf `handleType` is 0, [`crate::vk::PFN_vkGetPhysicalDeviceImageFormatProperties2`]will behave as if [`crate::vk::PhysicalDeviceExternalImageFormatInfo`] was not\npresent, and [`crate::vk::ExternalImageFormatProperties`] will be ignored.\n\nIf `handleType` is not compatible with the `format`, `type`,`tiling`, `usage`, and `flags` specified in[`crate::vk::PhysicalDeviceImageFormatInfo2`], then[`crate::vk::PFN_vkGetPhysicalDeviceImageFormatProperties2`] returns[`crate::vk::Result::ERROR_FORMAT_NOT_SUPPORTED`].\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceExternalImageFormatInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_EXTERNAL_IMAGE_FORMAT_INFO`]\n\n* []() VUID-VkPhysicalDeviceExternalImageFormatInfo-handleType-parameter  \n   If `handleType` is not `0`, `handleType` **must** be a valid [VkExternalMemoryHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryHandleTypeFlagBits.html) value\n[](#_see_also)See Also\n----------\n\n[VkExternalMemoryHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryHandleTypeFlagBits.html), [`crate::vk::StructureType`]\n"]
#[doc(alias = "VkPhysicalDeviceExternalImageFormatInfoKHR")]
#[allow(non_camel_case_types)]
pub type PhysicalDeviceExternalImageFormatInfoKHRBuilder<'a> = crate::vk1_1::PhysicalDeviceExternalImageFormatInfoBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalImageFormatPropertiesKHR.html)) · Alias <br/> VkExternalImageFormatProperties - Structure specifying supported external handle properties\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::ExternalImageFormatProperties`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkExternalImageFormatProperties {\n    VkStructureType               sType;\n    void*                         pNext;\n    VkExternalMemoryProperties    externalMemoryProperties;\n} VkExternalImageFormatProperties;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_memory_capabilities\ntypedef VkExternalImageFormatProperties VkExternalImageFormatPropertiesKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `externalMemoryProperties` is a [`crate::vk::ExternalMemoryProperties`]structure specifying various capabilities of the external handle type\n  when used with the specified image creation parameters.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-VkExternalImageFormatProperties-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::EXTERNAL_IMAGE_FORMAT_PROPERTIES`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExternalMemoryProperties`], [`crate::vk::StructureType`]\n"]
#[doc(alias = "VkExternalImageFormatPropertiesKHR")]
#[allow(non_camel_case_types)]
pub type ExternalImageFormatPropertiesKHR = crate::vk1_1::ExternalImageFormatProperties;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalImageFormatPropertiesKHR.html)) · Alias <br/> VkExternalImageFormatProperties - Structure specifying supported external handle properties\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::ExternalImageFormatProperties`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkExternalImageFormatProperties {\n    VkStructureType               sType;\n    void*                         pNext;\n    VkExternalMemoryProperties    externalMemoryProperties;\n} VkExternalImageFormatProperties;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_memory_capabilities\ntypedef VkExternalImageFormatProperties VkExternalImageFormatPropertiesKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `externalMemoryProperties` is a [`crate::vk::ExternalMemoryProperties`]structure specifying various capabilities of the external handle type\n  when used with the specified image creation parameters.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-VkExternalImageFormatProperties-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::EXTERNAL_IMAGE_FORMAT_PROPERTIES`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExternalMemoryProperties`], [`crate::vk::StructureType`]\n"]
#[doc(alias = "VkExternalImageFormatPropertiesKHR")]
#[allow(non_camel_case_types)]
pub type ExternalImageFormatPropertiesKHRBuilder<'a> = crate::vk1_1::ExternalImageFormatPropertiesBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceExternalBufferInfoKHR.html)) · Alias <br/> VkPhysicalDeviceExternalBufferInfo - Structure specifying buffer creation parameters\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceExternalBufferInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkPhysicalDeviceExternalBufferInfo {\n    VkStructureType                       sType;\n    const void*                           pNext;\n    VkBufferCreateFlags                   flags;\n    VkBufferUsageFlags                    usage;\n    VkExternalMemoryHandleTypeFlagBits    handleType;\n} VkPhysicalDeviceExternalBufferInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_memory_capabilities\ntypedef VkPhysicalDeviceExternalBufferInfo VkPhysicalDeviceExternalBufferInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `flags` is a bitmask of [VkBufferCreateFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkBufferCreateFlagBits.html) describing\n  additional parameters of the buffer, corresponding to[`crate::vk::BufferCreateInfo::flags`].\n\n* `usage` is a bitmask of [VkBufferUsageFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkBufferUsageFlagBits.html) describing the\n  intended usage of the buffer, corresponding to[`crate::vk::BufferCreateInfo::usage`].\n\n* `handleType` is a [VkExternalMemoryHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryHandleTypeFlagBits.html) value\n  specifying the memory handle type that will be used with the memory\n  associated with the buffer.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceExternalBufferInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_EXTERNAL_BUFFER_INFO`]\n\n* []() VUID-VkPhysicalDeviceExternalBufferInfo-pNext-pNext  \n  `pNext` **must** be `NULL`\n\n* []() VUID-VkPhysicalDeviceExternalBufferInfo-flags-parameter  \n  `flags` **must** be a valid combination of [VkBufferCreateFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkBufferCreateFlagBits.html) values\n\n* []() VUID-VkPhysicalDeviceExternalBufferInfo-usage-parameter  \n  `usage` **must** be a valid combination of [VkBufferUsageFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkBufferUsageFlagBits.html) values\n\n* []() VUID-VkPhysicalDeviceExternalBufferInfo-usage-requiredbitmask  \n  `usage` **must** not be `0`\n\n* []() VUID-VkPhysicalDeviceExternalBufferInfo-handleType-parameter  \n  `handleType` **must** be a valid [VkExternalMemoryHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryHandleTypeFlagBits.html) value\n[](#_see_also)See Also\n----------\n\n[`crate::vk::BufferCreateFlagBits`], [`crate::vk::BufferUsageFlagBits`], [VkExternalMemoryHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryHandleTypeFlagBits.html), [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalBufferProperties`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalBufferProperties`]\n"]
#[doc(alias = "VkPhysicalDeviceExternalBufferInfoKHR")]
#[allow(non_camel_case_types)]
pub type PhysicalDeviceExternalBufferInfoKHR = crate::vk1_1::PhysicalDeviceExternalBufferInfo;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceExternalBufferInfoKHR.html)) · Alias <br/> VkPhysicalDeviceExternalBufferInfo - Structure specifying buffer creation parameters\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceExternalBufferInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkPhysicalDeviceExternalBufferInfo {\n    VkStructureType                       sType;\n    const void*                           pNext;\n    VkBufferCreateFlags                   flags;\n    VkBufferUsageFlags                    usage;\n    VkExternalMemoryHandleTypeFlagBits    handleType;\n} VkPhysicalDeviceExternalBufferInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_memory_capabilities\ntypedef VkPhysicalDeviceExternalBufferInfo VkPhysicalDeviceExternalBufferInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `flags` is a bitmask of [VkBufferCreateFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkBufferCreateFlagBits.html) describing\n  additional parameters of the buffer, corresponding to[`crate::vk::BufferCreateInfo::flags`].\n\n* `usage` is a bitmask of [VkBufferUsageFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkBufferUsageFlagBits.html) describing the\n  intended usage of the buffer, corresponding to[`crate::vk::BufferCreateInfo::usage`].\n\n* `handleType` is a [VkExternalMemoryHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryHandleTypeFlagBits.html) value\n  specifying the memory handle type that will be used with the memory\n  associated with the buffer.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceExternalBufferInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_EXTERNAL_BUFFER_INFO`]\n\n* []() VUID-VkPhysicalDeviceExternalBufferInfo-pNext-pNext  \n  `pNext` **must** be `NULL`\n\n* []() VUID-VkPhysicalDeviceExternalBufferInfo-flags-parameter  \n  `flags` **must** be a valid combination of [VkBufferCreateFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkBufferCreateFlagBits.html) values\n\n* []() VUID-VkPhysicalDeviceExternalBufferInfo-usage-parameter  \n  `usage` **must** be a valid combination of [VkBufferUsageFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkBufferUsageFlagBits.html) values\n\n* []() VUID-VkPhysicalDeviceExternalBufferInfo-usage-requiredbitmask  \n  `usage` **must** not be `0`\n\n* []() VUID-VkPhysicalDeviceExternalBufferInfo-handleType-parameter  \n  `handleType` **must** be a valid [VkExternalMemoryHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryHandleTypeFlagBits.html) value\n[](#_see_also)See Also\n----------\n\n[`crate::vk::BufferCreateFlagBits`], [`crate::vk::BufferUsageFlagBits`], [VkExternalMemoryHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalMemoryHandleTypeFlagBits.html), [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalBufferProperties`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalBufferProperties`]\n"]
#[doc(alias = "VkPhysicalDeviceExternalBufferInfoKHR")]
#[allow(non_camel_case_types)]
pub type PhysicalDeviceExternalBufferInfoKHRBuilder<'a> = crate::vk1_1::PhysicalDeviceExternalBufferInfoBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalBufferPropertiesKHR.html)) · Alias <br/> VkExternalBufferProperties - Structure specifying supported external handle capabilities\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::ExternalBufferProperties`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkExternalBufferProperties {\n    VkStructureType               sType;\n    void*                         pNext;\n    VkExternalMemoryProperties    externalMemoryProperties;\n} VkExternalBufferProperties;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_memory_capabilities\ntypedef VkExternalBufferProperties VkExternalBufferPropertiesKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `externalMemoryProperties` is a [`crate::vk::ExternalMemoryProperties`]structure specifying various capabilities of the external handle type\n  when used with the specified buffer creation parameters.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-VkExternalBufferProperties-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::EXTERNAL_BUFFER_PROPERTIES`]\n\n* []() VUID-VkExternalBufferProperties-pNext-pNext  \n  `pNext` **must** be `NULL`\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExternalMemoryProperties`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalBufferProperties`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalBufferProperties`]\n"]
#[doc(alias = "VkExternalBufferPropertiesKHR")]
#[allow(non_camel_case_types)]
pub type ExternalBufferPropertiesKHR = crate::vk1_1::ExternalBufferProperties;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalBufferPropertiesKHR.html)) · Alias <br/> VkExternalBufferProperties - Structure specifying supported external handle capabilities\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::ExternalBufferProperties`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkExternalBufferProperties {\n    VkStructureType               sType;\n    void*                         pNext;\n    VkExternalMemoryProperties    externalMemoryProperties;\n} VkExternalBufferProperties;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_memory_capabilities\ntypedef VkExternalBufferProperties VkExternalBufferPropertiesKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `externalMemoryProperties` is a [`crate::vk::ExternalMemoryProperties`]structure specifying various capabilities of the external handle type\n  when used with the specified buffer creation parameters.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-VkExternalBufferProperties-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::EXTERNAL_BUFFER_PROPERTIES`]\n\n* []() VUID-VkExternalBufferProperties-pNext-pNext  \n  `pNext` **must** be `NULL`\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExternalMemoryProperties`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalBufferProperties`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalBufferProperties`]\n"]
#[doc(alias = "VkExternalBufferPropertiesKHR")]
#[allow(non_camel_case_types)]
pub type ExternalBufferPropertiesKHRBuilder<'a> = crate::vk1_1::ExternalBufferPropertiesBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceIDPropertiesKHR.html)) · Alias <br/> VkPhysicalDeviceIDProperties - Structure specifying IDs related to the physical device\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceIDProperties`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkPhysicalDeviceIDProperties {\n    VkStructureType    sType;\n    void*              pNext;\n    uint8_t            deviceUUID[VK_UUID_SIZE];\n    uint8_t            driverUUID[VK_UUID_SIZE];\n    uint8_t            deviceLUID[VK_LUID_SIZE];\n    uint32_t           deviceNodeMask;\n    VkBool32           deviceLUIDValid;\n} VkPhysicalDeviceIDProperties;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_memory_capabilities, VK_KHR_external_semaphore_capabilities, VK_KHR_external_fence_capabilities\ntypedef VkPhysicalDeviceIDProperties VkPhysicalDeviceIDPropertiesKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n[](#_description)Description\n----------\n\n* `deviceUUID` is an array of [`crate::vk::UUID_SIZE`] `uint8_t` values\n  representing a universally unique identifier for the device.\n\n* `driverUUID` is an array of [`crate::vk::UUID_SIZE`] `uint8_t` values\n  representing a universally unique identifier for the driver build in use\n  by the device.\n\n* `deviceLUID` is an array of [`crate::vk::LUID_SIZE`] `uint8_t` values\n  representing a locally unique identifier for the device.\n\n* `deviceNodeMask` is a `uint32_t` bitfield identifying the node\n  within a linked device adapter corresponding to the device.\n\n* `deviceLUIDValid` is a boolean value that will be [`crate::vk::TRUE`] if`deviceLUID` contains a valid LUID and `deviceNodeMask` contains\n  a valid node mask, and [`crate::vk::FALSE`] if they do not.\n\nIf the [`crate::vk::PhysicalDeviceIDProperties`] structure is included in the `pNext` chain of the[`crate::vk::PhysicalDeviceProperties2`] structure passed to[`crate::vk::PFN_vkGetPhysicalDeviceProperties2`], it is filled in with each\ncorresponding implementation-dependent property.\n\n`deviceUUID` **must** be immutable for a given device across instances,\nprocesses, driver APIs, driver versions, and system reboots.\n\nApplications **can** compare the `driverUUID` value across instance and\nprocess boundaries, and **can** make similar queries in external APIs to\ndetermine whether they are capable of sharing memory objects and resources\nusing them with the device.\n\n`deviceUUID` and/or `driverUUID` **must** be used to determine whether\na particular external object can be shared between driver components, where\nsuch a restriction exists as defined in the compatibility table for the\nparticular object type:\n\n* [External memory handle\n  types compatibility](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#external-memory-handle-types-compatibility)\n\n* [External semaphore\n  handle types compatibility](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#external-semaphore-handle-types-compatibility)\n\n* [External fence handle types\n  compatibility](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#external-fence-handle-types-compatibility)\n\nIf `deviceLUIDValid` is [`crate::vk::FALSE`], the values of `deviceLUID`and `deviceNodeMask` are undefined.\nIf `deviceLUIDValid` is [`crate::vk::TRUE`] and Vulkan is running on the\nWindows operating system, the contents of `deviceLUID` **can** be cast to\nan `LUID` object and **must** be equal to the locally unique identifier of a`IDXGIAdapter1` object that corresponds to `physicalDevice`.\nIf `deviceLUIDValid` is [`crate::vk::TRUE`], `deviceNodeMask` **must**contain exactly one bit.\nIf Vulkan is running on an operating system that supports the Direct3D 12\nAPI and `physicalDevice` corresponds to an individual device in a linked\ndevice adapter, `deviceNodeMask` identifies the Direct3D 12 node\ncorresponding to `physicalDevice`.\nOtherwise, `deviceNodeMask` **must** be `1`.\n\n|   |Note<br/><br/>Although they have identical descriptions,[`crate::vk::PhysicalDeviceIDProperties::device_uuid`] may differ from[`crate::vk::PhysicalDeviceProperties2::pipeline_cache_uuid`].<br/>The former is intended to identify and correlate devices across API and<br/>driver boundaries, while the latter is used to identify a compatible device<br/>and driver combination to use when serializing and de-serializing pipeline<br/>state.<br/><br/>Implementations **should** return `deviceUUID` values which are likely to<br/>be unique even in the presence of multiple Vulkan implementations (such as a<br/>GPU driver and a software renderer; two drivers for different GPUs; or the<br/>same Vulkan driver running on two logically different devices).<br/><br/>Khronos' conformance testing can not guarantee that `deviceUUID` values<br/>are actually unique, so implementors should make their own best efforts to<br/>ensure this.<br/>In particular, hard-coded `deviceUUID` values, especially all-`0` bits,**should** never be used.<br/><br/>A combination of values unique to the vendor, the driver, and the hardware<br/>environment can be used to provide a `deviceUUID` which is unique to a<br/>high degree of certainty.<br/>Some possible inputs to such a computation are:<br/><br/>* Information reported by [`crate::vk::PFN_vkGetPhysicalDeviceProperties`]<br/><br/>* PCI device ID (if defined)<br/><br/>* PCI bus ID, or similar system configuration information.<br/><br/>* Driver binary checksums.|\n|---|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\n|   |Note<br/><br/>While [`crate::vk::PhysicalDeviceIDProperties::device_uuid`] is specified to<br/>remain consistent across driver versions and system reboots, it is not<br/>intended to be usable as a serializable persistent identifier for a device.<br/>It may change when a device is physically added to, removed from, or moved<br/>to a different connector in a system while that system is powered down.<br/>Further, there is no reasonable way to verify with conformance testing that<br/>a given device retains the same UUID in a given system across all driver<br/>versions supported in that system.<br/>While implementations should make every effort to report consistent device<br/>UUIDs across driver versions, applications should avoid relying on the<br/>persistence of this value for uses other than identifying compatible devices<br/>for external object sharing purposes.|\n|---|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceIDProperties-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_ID_PROPERTIES`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Bool32`], [`crate::vk::StructureType`]\n"]
#[doc(alias = "VkPhysicalDeviceIDPropertiesKHR")]
#[allow(non_camel_case_types)]
pub type PhysicalDeviceIDPropertiesKHR = crate::vk1_1::PhysicalDeviceIDProperties;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceIDPropertiesKHR.html)) · Alias <br/> VkPhysicalDeviceIDProperties - Structure specifying IDs related to the physical device\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceIDProperties`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkPhysicalDeviceIDProperties {\n    VkStructureType    sType;\n    void*              pNext;\n    uint8_t            deviceUUID[VK_UUID_SIZE];\n    uint8_t            driverUUID[VK_UUID_SIZE];\n    uint8_t            deviceLUID[VK_LUID_SIZE];\n    uint32_t           deviceNodeMask;\n    VkBool32           deviceLUIDValid;\n} VkPhysicalDeviceIDProperties;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_memory_capabilities, VK_KHR_external_semaphore_capabilities, VK_KHR_external_fence_capabilities\ntypedef VkPhysicalDeviceIDProperties VkPhysicalDeviceIDPropertiesKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n[](#_description)Description\n----------\n\n* `deviceUUID` is an array of [`crate::vk::UUID_SIZE`] `uint8_t` values\n  representing a universally unique identifier for the device.\n\n* `driverUUID` is an array of [`crate::vk::UUID_SIZE`] `uint8_t` values\n  representing a universally unique identifier for the driver build in use\n  by the device.\n\n* `deviceLUID` is an array of [`crate::vk::LUID_SIZE`] `uint8_t` values\n  representing a locally unique identifier for the device.\n\n* `deviceNodeMask` is a `uint32_t` bitfield identifying the node\n  within a linked device adapter corresponding to the device.\n\n* `deviceLUIDValid` is a boolean value that will be [`crate::vk::TRUE`] if`deviceLUID` contains a valid LUID and `deviceNodeMask` contains\n  a valid node mask, and [`crate::vk::FALSE`] if they do not.\n\nIf the [`crate::vk::PhysicalDeviceIDProperties`] structure is included in the `pNext` chain of the[`crate::vk::PhysicalDeviceProperties2`] structure passed to[`crate::vk::PFN_vkGetPhysicalDeviceProperties2`], it is filled in with each\ncorresponding implementation-dependent property.\n\n`deviceUUID` **must** be immutable for a given device across instances,\nprocesses, driver APIs, driver versions, and system reboots.\n\nApplications **can** compare the `driverUUID` value across instance and\nprocess boundaries, and **can** make similar queries in external APIs to\ndetermine whether they are capable of sharing memory objects and resources\nusing them with the device.\n\n`deviceUUID` and/or `driverUUID` **must** be used to determine whether\na particular external object can be shared between driver components, where\nsuch a restriction exists as defined in the compatibility table for the\nparticular object type:\n\n* [External memory handle\n  types compatibility](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#external-memory-handle-types-compatibility)\n\n* [External semaphore\n  handle types compatibility](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#external-semaphore-handle-types-compatibility)\n\n* [External fence handle types\n  compatibility](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#external-fence-handle-types-compatibility)\n\nIf `deviceLUIDValid` is [`crate::vk::FALSE`], the values of `deviceLUID`and `deviceNodeMask` are undefined.\nIf `deviceLUIDValid` is [`crate::vk::TRUE`] and Vulkan is running on the\nWindows operating system, the contents of `deviceLUID` **can** be cast to\nan `LUID` object and **must** be equal to the locally unique identifier of a`IDXGIAdapter1` object that corresponds to `physicalDevice`.\nIf `deviceLUIDValid` is [`crate::vk::TRUE`], `deviceNodeMask` **must**contain exactly one bit.\nIf Vulkan is running on an operating system that supports the Direct3D 12\nAPI and `physicalDevice` corresponds to an individual device in a linked\ndevice adapter, `deviceNodeMask` identifies the Direct3D 12 node\ncorresponding to `physicalDevice`.\nOtherwise, `deviceNodeMask` **must** be `1`.\n\n|   |Note<br/><br/>Although they have identical descriptions,[`crate::vk::PhysicalDeviceIDProperties::device_uuid`] may differ from[`crate::vk::PhysicalDeviceProperties2::pipeline_cache_uuid`].<br/>The former is intended to identify and correlate devices across API and<br/>driver boundaries, while the latter is used to identify a compatible device<br/>and driver combination to use when serializing and de-serializing pipeline<br/>state.<br/><br/>Implementations **should** return `deviceUUID` values which are likely to<br/>be unique even in the presence of multiple Vulkan implementations (such as a<br/>GPU driver and a software renderer; two drivers for different GPUs; or the<br/>same Vulkan driver running on two logically different devices).<br/><br/>Khronos' conformance testing can not guarantee that `deviceUUID` values<br/>are actually unique, so implementors should make their own best efforts to<br/>ensure this.<br/>In particular, hard-coded `deviceUUID` values, especially all-`0` bits,**should** never be used.<br/><br/>A combination of values unique to the vendor, the driver, and the hardware<br/>environment can be used to provide a `deviceUUID` which is unique to a<br/>high degree of certainty.<br/>Some possible inputs to such a computation are:<br/><br/>* Information reported by [`crate::vk::PFN_vkGetPhysicalDeviceProperties`]<br/><br/>* PCI device ID (if defined)<br/><br/>* PCI bus ID, or similar system configuration information.<br/><br/>* Driver binary checksums.|\n|---|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\n|   |Note<br/><br/>While [`crate::vk::PhysicalDeviceIDProperties::device_uuid`] is specified to<br/>remain consistent across driver versions and system reboots, it is not<br/>intended to be usable as a serializable persistent identifier for a device.<br/>It may change when a device is physically added to, removed from, or moved<br/>to a different connector in a system while that system is powered down.<br/>Further, there is no reasonable way to verify with conformance testing that<br/>a given device retains the same UUID in a given system across all driver<br/>versions supported in that system.<br/>While implementations should make every effort to report consistent device<br/>UUIDs across driver versions, applications should avoid relying on the<br/>persistence of this value for uses other than identifying compatible devices<br/>for external object sharing purposes.|\n|---|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceIDProperties-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_ID_PROPERTIES`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Bool32`], [`crate::vk::StructureType`]\n"]
#[doc(alias = "VkPhysicalDeviceIDPropertiesKHR")]
#[allow(non_camel_case_types)]
pub type PhysicalDeviceIDPropertiesKHRBuilder<'a> = crate::vk1_1::PhysicalDeviceIDPropertiesBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetPhysicalDeviceExternalBufferPropertiesKHR.html)) · Alias <br/> vkGetPhysicalDeviceExternalBufferProperties - Query external handle types supported by buffers\n[](#_c_specification)C Specification\n----------\n\nTo query the external handle types supported by buffers, call:\n\n```\n// Provided by VK_VERSION_1_1\nvoid vkGetPhysicalDeviceExternalBufferProperties(\n    VkPhysicalDevice                            physicalDevice,\n    const VkPhysicalDeviceExternalBufferInfo*   pExternalBufferInfo,\n    VkExternalBufferProperties*                 pExternalBufferProperties);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_external_memory_capabilities\nvoid vkGetPhysicalDeviceExternalBufferPropertiesKHR(\n    VkPhysicalDevice                            physicalDevice,\n    const VkPhysicalDeviceExternalBufferInfo*   pExternalBufferInfo,\n    VkExternalBufferProperties*                 pExternalBufferProperties);\n```\n[](#_parameters)Parameters\n----------\n\n* `physicalDevice` is the physical device from which to query the\n  buffer capabilities.\n\n* `pExternalBufferInfo` is a pointer to a[`crate::vk::PhysicalDeviceExternalBufferInfo`] structure describing the\n  parameters that would be consumed by [`crate::vk::PFN_vkCreateBuffer`].\n\n* `pExternalBufferProperties` is a pointer to a[`crate::vk::ExternalBufferProperties`] structure in which capabilities are\n  returned.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetPhysicalDeviceExternalBufferProperties-physicalDevice-parameter  \n  `physicalDevice` **must** be a valid [`crate::vk::PhysicalDevice`] handle\n\n* []() VUID-vkGetPhysicalDeviceExternalBufferProperties-pExternalBufferInfo-parameter  \n  `pExternalBufferInfo` **must** be a valid pointer to a valid [`crate::vk::PhysicalDeviceExternalBufferInfo`] structure\n\n* []() VUID-vkGetPhysicalDeviceExternalBufferProperties-pExternalBufferProperties-parameter  \n  `pExternalBufferProperties` **must** be a valid pointer to a [`crate::vk::ExternalBufferProperties`] structure\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExternalBufferProperties`], [`crate::vk::PhysicalDevice`], [`crate::vk::PhysicalDeviceExternalBufferInfo`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkGetPhysicalDeviceExternalBufferPropertiesKHR = crate::vk1_1::PFN_vkGetPhysicalDeviceExternalBufferProperties;
#[doc = "Provided by [`crate::extensions::khr_external_memory_capabilities`]"]
impl crate::vk1_0::StructureType {
    pub const PHYSICAL_DEVICE_EXTERNAL_IMAGE_FORMAT_INFO_KHR: Self = Self::PHYSICAL_DEVICE_EXTERNAL_IMAGE_FORMAT_INFO;
    pub const EXTERNAL_IMAGE_FORMAT_PROPERTIES_KHR: Self = Self::EXTERNAL_IMAGE_FORMAT_PROPERTIES;
    pub const PHYSICAL_DEVICE_EXTERNAL_BUFFER_INFO_KHR: Self = Self::PHYSICAL_DEVICE_EXTERNAL_BUFFER_INFO;
    pub const EXTERNAL_BUFFER_PROPERTIES_KHR: Self = Self::EXTERNAL_BUFFER_PROPERTIES;
    pub const PHYSICAL_DEVICE_ID_PROPERTIES_KHR: Self = Self::PHYSICAL_DEVICE_ID_PROPERTIES;
}
#[doc = "Provided by [`crate::extensions::khr_external_memory_capabilities`]"]
impl crate::vk1_1::ExternalMemoryHandleTypeFlagBits {
    pub const OPAQUE_FD_KHR: Self = Self::OPAQUE_FD;
    pub const OPAQUE_WIN32_KHR: Self = Self::OPAQUE_WIN32;
    pub const OPAQUE_WIN32_KMT_KHR: Self = Self::OPAQUE_WIN32_KMT;
    pub const D3D11_TEXTURE_KHR: Self = Self::D3D11_TEXTURE;
    pub const D3D11_TEXTURE_KMT_KHR: Self = Self::D3D11_TEXTURE_KMT;
    pub const D3D12_HEAP_KHR: Self = Self::D3D12_HEAP;
    pub const D3D12_RESOURCE_KHR: Self = Self::D3D12_RESOURCE;
}
#[doc = "Provided by [`crate::extensions::khr_external_memory_capabilities`]"]
impl crate::vk1_1::ExternalMemoryFeatureFlagBits {
    pub const DEDICATED_ONLY_KHR: Self = Self::DEDICATED_ONLY;
    pub const EXPORTABLE_KHR: Self = Self::EXPORTABLE;
    pub const IMPORTABLE_KHR: Self = Self::IMPORTABLE;
}
#[doc = "Provided by [`crate::extensions::khr_external_memory_capabilities`]"]
impl crate::InstanceLoader {
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetPhysicalDeviceExternalBufferPropertiesKHR.html)) · Function <br/> vkGetPhysicalDeviceExternalBufferProperties - Query external handle types supported by buffers\n[](#_c_specification)C Specification\n----------\n\nTo query the external handle types supported by buffers, call:\n\n```\n// Provided by VK_VERSION_1_1\nvoid vkGetPhysicalDeviceExternalBufferProperties(\n    VkPhysicalDevice                            physicalDevice,\n    const VkPhysicalDeviceExternalBufferInfo*   pExternalBufferInfo,\n    VkExternalBufferProperties*                 pExternalBufferProperties);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_external_memory_capabilities\nvoid vkGetPhysicalDeviceExternalBufferPropertiesKHR(\n    VkPhysicalDevice                            physicalDevice,\n    const VkPhysicalDeviceExternalBufferInfo*   pExternalBufferInfo,\n    VkExternalBufferProperties*                 pExternalBufferProperties);\n```\n[](#_parameters)Parameters\n----------\n\n* `physicalDevice` is the physical device from which to query the\n  buffer capabilities.\n\n* `pExternalBufferInfo` is a pointer to a[`crate::vk::PhysicalDeviceExternalBufferInfo`] structure describing the\n  parameters that would be consumed by [`crate::vk::PFN_vkCreateBuffer`].\n\n* `pExternalBufferProperties` is a pointer to a[`crate::vk::ExternalBufferProperties`] structure in which capabilities are\n  returned.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetPhysicalDeviceExternalBufferProperties-physicalDevice-parameter  \n  `physicalDevice` **must** be a valid [`crate::vk::PhysicalDevice`] handle\n\n* []() VUID-vkGetPhysicalDeviceExternalBufferProperties-pExternalBufferInfo-parameter  \n  `pExternalBufferInfo` **must** be a valid pointer to a valid [`crate::vk::PhysicalDeviceExternalBufferInfo`] structure\n\n* []() VUID-vkGetPhysicalDeviceExternalBufferProperties-pExternalBufferProperties-parameter  \n  `pExternalBufferProperties` **must** be a valid pointer to a [`crate::vk::ExternalBufferProperties`] structure\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExternalBufferProperties`], [`crate::vk::PhysicalDevice`], [`crate::vk::PhysicalDeviceExternalBufferInfo`]\n"]
    #[doc(alias = "vkGetPhysicalDeviceExternalBufferPropertiesKHR")]
    pub unsafe fn get_physical_device_external_buffer_properties_khr(&self, physical_device: crate::vk1_0::PhysicalDevice, external_buffer_info: &crate::vk1_1::PhysicalDeviceExternalBufferInfo, external_buffer_properties: Option<crate::vk1_1::ExternalBufferProperties>) -> crate::vk1_1::ExternalBufferProperties {
        let _function = self.get_physical_device_external_buffer_properties_khr.expect(crate::NOT_LOADED_MESSAGE);
        let mut external_buffer_properties = match external_buffer_properties {
            Some(v) => v,
            None => Default::default(),
        };
        let _return = _function(physical_device as _, external_buffer_info as _, &mut external_buffer_properties);
        {
            external_buffer_properties.p_next = std::ptr::null_mut() as _;
            external_buffer_properties
        }
    }
}
